#ifndef __BS_JOINT_H__
#define __BS_JOINT_H__

#include "bs_vector.h"
#include "bs_pointmass.h"
#include "bs_types.h"

typedef struct bs_joint_st 
{
  bs_vector_t *pAPos, *pBPos;
  bs_float_t shortConstSquared;   
  bs_float_t longConstSquared;   
} bs_joint_t; 

bs_joint_t* 
bs_joint_create(bs_pointmass_t *pPointmassA, 
                bs_pointmass_t *pPointmassB, 
                bs_float_t shortConst, 
                bs_float_t longConst); 

void 
bs_joint_destroy(bs_joint_t *pJoint); 

void 
bs_joint_set_consts(bs_joint_t *pJoint, 
                    bs_float_t shortConst, 
                    bs_float_t longConst); 

void 
bs_joint_scale(bs_joint_t *pJoint, 
               bs_float_t scaleFactor); 

void 
bs_joint_sc(bs_joint_t *pJoint); 

#endif
